/*-------------------------------------------------------------------
   SCRNSIZE.C - Zeigt die Bildschirmgre in einem Meldungsfenster an
                (c) Charles Petzold, 1998
  -------------------------------------------------------------------*/

#include <windows.h>
#include <tchar.h>     
#include <stdio.h>     

int CDECL MessageBoxPrintf (TCHAR * szCaption, TCHAR * szFormat, ...)
{
     TCHAR   szBuffer [1024] ;
     va_list pArgList ;

     // Der in STDARG.H definierte Makro va_start entspricht:
     // pArgList = (char *) &szFormat + sizeof (szFormat) ;
     va_start (pArgList, szFormat) ;

     // Der letzte Parameter von wvsprintf zeigt auf die Parameter
     _vsntprintf (szBuffer, sizeof (szBuffer) / sizeof (TCHAR), szFormat, pArgList) ;

     // va_end tut nichts weitere, als pArgList auf NULL zu setzen
     va_end (pArgList) ;

     return MessageBox (NULL, szBuffer, szCaption, 0) ;
}

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow) 
{
     int cxScreen, cyScreen ;

     cxScreen = GetSystemMetrics (SM_CXSCREEN) ;
     cyScreen = GetSystemMetrics (SM_CYSCREEN) ;

     MessageBoxPrintf (TEXT ("ScrnSize"), 
                       TEXT ("Ihr Desktop hat eine Hhe von %i und eine Breite von %i Pixeln"),
                       cxScreen, cyScreen) ;
     return 0 ;
}
