/*----------------------------------------------------
   SYSMETS.H -- Strukturdefinition fr die Ergebnisse 
                von GetSystemMetrics
  ----------------------------------------------------*/

#define NUMLINES (sizeof sysmetrics / sizeof sysmetrics [0])

struct 
 { int  iIndex ;
   TCHAR *szLabel ;
   TCHAR *szDesc ;
 } sysmetrics [] =
{
     SM_CXSCREEN,             TEXT ("SM_CXSCREEN"),              
                              TEXT ("Bildschirmbreite in Pixeln"),
     SM_CYSCREEN,             TEXT ("SM_CYSCREEN"),              
                              TEXT ("Bildschirmhhe in Pixeln"),
     SM_CXVSCROLL,            TEXT ("SM_CXVSCROLL"),             
                              TEXT ("Breite vertikaler Rollpfeil"),
     SM_CYHSCROLL,            TEXT ("SM_CYHSCROLL"),             
                              TEXT ("Hhe horizontaler Rollpfeil"),
     SM_CYCAPTION,            TEXT ("SM_CYCAPTION"),             
                              TEXT ("Hhe der Titelleiste"),
     SM_CXBORDER,             TEXT ("SM_CXBORDER"),              
                              TEXT ("Fensterrahmenbreite"),
     SM_CYBORDER,             TEXT ("SM_CYBORDER"),              
                              TEXT ("Fensterrahmenhhe"),
     SM_CXFIXEDFRAME,         TEXT ("SM_CXFIXEDFRAME"),          
                              TEXT ("Rahmenbreite von Dialogen"),
     SM_CYFIXEDFRAME,         TEXT ("SM_CYFIXEDFRAME"),          
                              TEXT ("Rahmenhhe von Dialogen"),
     SM_CYVTHUMB,             TEXT ("SM_CYVTHUMB"),              
                              TEXT ("Hhe der Marke in Bildlaufleisten"),
     SM_CXHTHUMB,             TEXT ("SM_CXHTHUMB"),              
                              TEXT ("Breite der Marke in Bildlaufleisten"),
     SM_CXICON,               TEXT ("SM_CXICON"),                
                              TEXT ("Breite von Icons"),
     SM_CYICON,               TEXT ("SM_CYICON"),                
                              TEXT ("Hhe von Icons"),
     SM_CXCURSOR,             TEXT ("SM_CXCURSOR"),              
                              TEXT ("Breite des Cursors"),
     SM_CYCURSOR,             TEXT ("SM_CYCURSOR"),              
                              TEXT ("Hhe des Cursors"),
     SM_CYMENU,               TEXT ("SM_CYMENU"),                
                              TEXT ("Hhe der Menleiste"),
     SM_CXFULLSCREEN,         TEXT ("SM_CXFULLSCREEN"),          
                              TEXT ("Max. Breite des Anwendungsbereichs"),
     SM_CYFULLSCREEN,         TEXT ("SM_CYFULLSCREEN"),          
                              TEXT ("Max. Hhe des Anwendungsbereichs"),
     SM_CYKANJIWINDOW,        TEXT ("SM_CYKANJIWINDOW"),         
                              TEXT ("Hhe von Kanji-Fenstern"),
     SM_MOUSEPRESENT,         TEXT ("SM_MOUSEPRESENT"),          
                              TEXT ("Flag fr \"Maus vorhanden\""),
     SM_CYVSCROLL,            TEXT ("SM_CYVSCROLL"),             
                              TEXT ("Hhe vertikaler Rollpfeil"),
     SM_CXHSCROLL,            TEXT ("SM_CXHSCROLL"),             
                              TEXT ("Breite horizontaler Rollpfeil"),
     SM_DEBUG,                TEXT ("SM_DEBUG"),                 
                              TEXT ("Flag fr \"Debug-Version\""),
     SM_SWAPBUTTON,           TEXT ("SM_SWAPBUTTON"),            
                              TEXT ("Flag fr \"Mausknpfe vertauscht\""),
     SM_CXMIN,                TEXT ("SM_CXMIN"),                 
                              TEXT ("Minimale Fensterbreite"),
     SM_CYMIN,                TEXT ("SM_CYMIN"),                 
                              TEXT ("Minimale Fensterhhe"),
     SM_CXSIZE,               TEXT ("SM_CXSIZE"),                
                              TEXT ("Breite der Titelleisten-Schaltflchen"),
     SM_CYSIZE,               TEXT ("SM_CYSIZE"),                
                              TEXT ("Hhe der Titelleisten-Schaltflchen"),
     SM_CXSIZEFRAME,          TEXT ("SM_CXSIZEFRAME"),           
                              TEXT ("Breite des Fensterrahmens fr Grenvernderungen"),
     SM_CYSIZEFRAME,          TEXT ("SM_CYSIZEFRAME"),           
                              TEXT ("Hhe des Fensterrahmens fr Grenvernderungen"),
     SM_CXMINTRACK,           TEXT ("SM_CXMINTRACK"),            
                              TEXT ("Minimalbreite fr Verschieben"),
     SM_CYMINTRACK,           TEXT ("SM_CYMINTRACK"),            
                              TEXT ("Minimalhhe fr Verschieben"),
     SM_CXDOUBLECLK,          TEXT ("SM_CXDOUBLECLK"),           
                              TEXT ("Max. X-Bewegung bei Doppelklicks"),
     SM_CYDOUBLECLK,          TEXT ("SM_CYDOUBLECLK"),           
                              TEXT ("Max. Y-Bewegung bei Doppelklicks"),
     SM_CXICONSPACING,        TEXT ("SM_CXICONSPACING"),         
                              TEXT ("Horizontaler Abstand von Icons"),
     SM_CYICONSPACING,        TEXT ("SM_CYICONSPACING"),         
                              TEXT ("Vertikaler Abstand von Icons"),
     SM_MENUDROPALIGNMENT,    TEXT ("SM_MENUDROPALIGNMENT"),     
                              TEXT ("Mens links oder rechts"),
     SM_PENWINDOWS,           TEXT ("SM_PENWINDOWS"),            
                              TEXT ("Pen-Erweiterungen installiert"),
     SM_DBCSENABLED,          TEXT ("SM_DBCSENABLED"),           
                              TEXT ("Doublebyte-Zeichensatz aktiviert"),
     SM_CMOUSEBUTTONS,        TEXT ("SM_CMOUSEBUTTONS"),         
                              TEXT ("Anzahl Maustasten"),
     SM_SECURE,               TEXT ("SM_SECURE"),                
                              TEXT ("Flag fr \"Sicherheit vorhanden\""),
     SM_CXEDGE,               TEXT ("SM_CXEDGE"),                
                              TEXT ("Breite von 3D-Rahmen"),
     SM_CYEDGE,               TEXT ("SM_CYEDGE"),                
                              TEXT ("Hhe von 3D-Rahmen"),
     SM_CXMINSPACING,         TEXT ("SM_CXMINSPACING"),          
                              TEXT ("Min. X-Abstand minimierter Fenster"),
     SM_CYMINSPACING,         TEXT ("SM_CYMINSPACING"),          
                              TEXT ("Min. Y-Abstand minimierter Fenster"),
     SM_CXSMICON,             TEXT ("SM_CXSMICON"),              
                              TEXT ("Breiter kleiner Icons"),
     SM_CYSMICON,             TEXT ("SM_CYSMICON"),              
                              TEXT ("Hhe kleiner Icons"),
     SM_CYSMCAPTION,          TEXT ("SM_CYSMCAPTION"),           
                              TEXT ("Hhe kleiner Titelleisten"),
     SM_CXSMSIZE,             TEXT ("SM_CXSMSIZE"),              
                              TEXT ("Schaltflchenbreite in kleinen Titelleisten"),
     SM_CYSMSIZE,             TEXT ("SM_CYSMSIZE"),              
                              TEXT ("Schaltflchenhhe in kleinen Titelleisten"),
     SM_CXMENUSIZE,           TEXT ("SM_CXMENUSIZE"),            
                              TEXT ("Schaltflchenbreite in Mens"),
     SM_CYMENUSIZE,           TEXT ("SM_CYMENUSIZE"),            
                              TEXT ("Schaltflchenhhe in Mens"),
     SM_ARRANGE,              TEXT ("SM_ARRANGE"),               
                              TEXT ("Anordnung minimierter Fenster"),
     SM_CXMINIMIZED,          TEXT ("SM_CXMINIMIZED"),           
                              TEXT ("Breite minimierter Fenster"),
     SM_CYMINIMIZED,          TEXT ("SM_CYMINIMIZED"),           
                              TEXT ("Hhe minimierter Fenster"),
     SM_CXMAXTRACK,           TEXT ("SM_CXMAXTRACK"),            
                              TEXT ("Mit Ziehen erreichbare Maximalbreite"),
     SM_CYMAXTRACK,           TEXT ("SM_CYMAXTRACK"),            
                              TEXT ("Mit Ziehen erreichbare Maximalhhe"),
     SM_CXMAXIMIZED,          TEXT ("SM_CXMAXIMIZED"),           
                              TEXT ("Breite maximierter Fenster"),
     SM_CYMAXIMIZED,          TEXT ("SM_CYMAXIMIZED"),           
                              TEXT ("Hhe maximierter Fenster"),
     SM_NETWORK,              TEXT ("SM_NETWORK"),               
                              TEXT ("Flag fr \"Netzwerk vorhanden\""),
     SM_CLEANBOOT,            TEXT ("SM_CLEANBOOT"),             
                              TEXT ("Art des Systemstarts"),
     SM_CXDRAG,               TEXT ("SM_CXDRAG"),                
                              TEXT ("Flag: \"Keine Minimalbewegung fr horizontales Ziehen\""),
     SM_CYDRAG,               TEXT ("SM_CYDRAG"),                
                              TEXT ("Flag: \"Keine Minimalbewegung fr vertikales Ziehen\""),
     SM_SHOWSOUNDS,           TEXT ("SM_SHOWSOUNDS"),            
                              TEXT ("Flag: \"Sounds mit Optik\" (fr Hrgeschdigte)"),
     SM_CXMENUCHECK,          TEXT ("SM_CXMENUCHECK"),           
                              TEXT ("Hkchenbreite in Mens"),
     SM_CYMENUCHECK,          TEXT ("SM_CYMENUCHECK"),           
                              TEXT ("Hkchenhhe in Mens"),
     SM_SLOWMACHINE,          TEXT ("SM_SLOWMACHINE"),           
                              TEXT ("Flag: \"Langsamer Prozessor\""),
     SM_MIDEASTENABLED,       TEXT ("SM_MIDEASTENABLED"),        
                              TEXT ("Flag: Arabisch/Hebrisch aktiviert")
#if (WINVER >= 0x500)		// diese Konstanten sind erst ab Windows NT 5.0 definiert					  
							  ,
     SM_MOUSEWHEELPRESENT,    TEXT ("SM_MOUSEWHEELPRESENT"),     
                              TEXT ("Flag: \"Mausrdchen vorhanden\""),
     SM_XVIRTUALSCREEN,       TEXT ("SM_XVIRTUALSCREEN"),        
                              TEXT ("Virtueller Bildschirm: X-Ursprung"),
     SM_YVIRTUALSCREEN,       TEXT ("SM_YVIRTUALSCREEN"),        
                              TEXT ("Virtueller Bildschirm: Y-Ursprung"),
     SM_CXVIRTUALSCREEN,      TEXT ("SM_CXVIRTUALSCREEN"),       
                              TEXT ("Virtueller Bildschirm: Breite"),
     SM_CYVIRTUALSCREEN,      TEXT ("SM_CYVIRTUALSCREEN"),       
                              TEXT ("Virtueller Bildschirm: Hhe"),
     SM_CMONITORS,            TEXT ("SM_CMONITORS"),             
                              TEXT ("Anzahl Monitore"),
     SM_SAMEDISPLAYFORMAT,    TEXT ("SM_SAMEDISPLAYFORMAT"),     
                              TEXT ("Gleiches Format fr alle Bildschirme")
#endif
} ;
