/*----------------------------------------
   STRLIB.H - Include-Datei fr STRLIB.DLL
  ----------------------------------------*/

#ifdef __cplusplus
#define EXPORT extern "C" __declspec (dllexport)
#else
#define EXPORT __declspec (dllexport)
#endif

// Maximale Anzahl und Lnge der Strings, mit denen STRLIB arbeitet
#define MAX_STRINGS 256
#define MAX_LENGTH  63

// Der Prototyp fr die Rckruffunktion (mit generischem Stringzeiger)
typedef BOOL (CALLBACK * GETSTRCB) (PCTSTR, PVOID) ;

// Jede Funktion ist als ANSI- und als Unicode-Variante definiert 
EXPORT BOOL CALLBACK AddStringA (PCSTR) ;
EXPORT BOOL CALLBACK AddStringW (PCWSTR) ;

EXPORT BOOL CALLBACK DeleteStringA (PCSTR) ;
EXPORT BOOL CALLBACK DeleteStringW (PCWSTR) ;

EXPORT int CALLBACK GetStringsA (GETSTRCB, PVOID) ;
EXPORT int CALLBACK GetStringsW (GETSTRCB, PVOID) ;
 
// Umsetzung auf A- oder W-Variante abhngig vom Symbol UNICODE
#ifdef UNICODE
#define AddString    AddStringW
#define DeleteString DeleteStringW
#define GetStrings   GetStringsW
#else
#define AddString    AddStringA
#define DeleteString DeleteStringA
#define GetStrings   GetStringsA
#endif
